/**************************************************************************** 
 **                                                                        **
 ** PROJEKT      : DLL zum Zugriff auf SPC Windows NT 4.0                  **
 ** MODUL        : SPC_DLL                                                 **
 ** DATEINAME    : SPCDLL.H                                                **
 **                                                                        **
 ** BESCHREIBUNG : Funktionen zum Zugriff auf SPC                          **
 **                                                                        **
 ** FIRMA        : TRS 78647 Trossingen Eglishalde 6                       **
 ** AUTOR        : Stefan Siedler                                          **
 **------------------------------------------------------------------------**
 ** REVISION     : 1.0                                                     **
 **                                                                        **
 ** DATUM     NAME          BEMERKUNG                                      **
 ** 05.05.97  S.Siedler                                                    **
 ****************************************************************************/



#ifdef __cplusplus
extern "C" {
#endif

typedef struct SPCDBFASTTYPE
{
   short iDBNr[5];
   short iOffset[5];
   short iAnzahl[5];
   char  *pData[5];
}SPCDBFAST;

typedef struct SPCREADWRITEDBTYPE
{
	short iAnforderung;
   short iDBNr[5];
   short iOffset[5];
   short iAnzahl[5];
   char  *pData[5];
}SPCREADWRITEDB;


#pragma pack(1)
typedef struct SPCREADWRITEDBTYPE2
{
	short iAnforderung;
   short iDBNr[5];
   short iOffset[5];
   short iAnzahl[5];
   char  *pData[5];
}SPCREADWRITEDB2;

typedef struct SPCDBFASTTYPE2
{
   short iDBNr[5];
   short iOffset[5];
   short iAnzahl[5];
   int   pData[5];
}SPCDBFAST2;
#pragma pack()

#pragma pack(4)
typedef struct SPCDBFASTTYPE3
{
   short iDBNr[5];
   short iOffset[5];
   short iAnzahl[5];
   short pData0[256];
   short pData1[256];
   short pData2[256];
   short pData3[256];
   short pData4[256];
}SPCDBFAST3;
#pragma pack()


/**********************************************************************************
 * Prototypen                                                                     *
 **********************************************************************************/
BOOL _stdcall SPC_Init(short iBoardID,short iBase);
BOOL _stdcall SPC_Init_NoPLC(short iBoardID);
BOOL _stdcall SPC_Exit(short iBoardID);
BOOL _stdcall SPC_Close();

short _stdcall SPC_ReadByte(short iBoardID,short Offset,unsigned char *Value);
short _stdcall SPC_ReadSPSWord(short iBoardID,short Offset, short *Value);
short _stdcall SPC_ReadWord(short iBoardID,short Offset, short *Value);
short _stdcall SPC_WriteByte(short iBoardID,short Offset,unsigned char Value);
short _stdcall SPC_WriteWord(short iBoardID,short Offset, short Value);
short _stdcall SPC_WriteSPSWord(short iBoardID,short Offset, short Value);

short _stdcall SPC_ReadZeiten(short iBoardID,short Nr, short *Value);
short _stdcall SPC_ReadZaehler(short iBoardID,short Nr, short *Value);
short _stdcall SPC_ReadMerkerWort(short iBoardID,short Nr, short *Value);
short _stdcall SPC_ReadMerkerByte(short iBoardID,short Nr, unsigned char *Value);
short _stdcall SPC_ReadPAEWort(short iBoardID,short Nr, short *Value);
short _stdcall SPC_ReadPAEByte(short iBoardID,short Nr, unsigned char *Value);
short _stdcall SPC_ReadPAAWort(short iBoardID,short Nr, short *Value);
short _stdcall SPC_ReadPAAByte(short iBoardID,short Nr, unsigned char *Value);
short _stdcall SPC_ReadPBEWort(short iBoardID,short Nr, short *Value);
short _stdcall SPC_ReadPBEByte(short iBoardID,short Nr, unsigned char *Value);
short _stdcall SPC_ReadPBAWort(short iBoardID,short Nr, short *Value);
short _stdcall SPC_ReadPBAByte(short iBoardID,short Nr, unsigned char *Value);
short _stdcall SPC_ReadDB(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_ReadKME(short iBoardID,short iOffset,short iAnzahl,char *pValue);
short _stdcall SPC_ReadMem(short iBoardID,DWORD dwOffset,DWORD dwLength,DWORD *dwBuffer);
short _stdcall SPC_WriteMem(short iBoardID,DWORD dwOffset,DWORD dwLength,DWORD *dwBuffer);

short _stdcall SPC_WriteDB(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_WriteKMA(short iBoardID,short iOffset,short iAnzahl,char *pValue);

short _stdcall SPC_ReadDB_NI(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_WriteDB_NI(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);

short _stdcall SPC_ReadFastDB(short iBoardID,SPCDBFAST stDB);
short _stdcall SPC_WriteFastDB(short iBoardID,SPCDBFAST stDB);

short _stdcall SPC_WriteFastDB2(short iBoardID,SPCDBFAST2 stDB);

short _stdcall SPC_ReadDB_Set(short iBoardID,SPCDBFAST *stDB);
short _stdcall SPC_ReadDB_Get(short iBoardID,SPCDBFAST *stDB);
short _stdcall SPC_WriteDB_Set(short iBoardID,SPCDBFAST *stDB);
short _stdcall SPC_WriteDB_Get(short iBoardID,SPCDBFAST *stDB);

short _stdcall SPC_ReadDBSingle_Set(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_ReadDBSingle_Get(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_WriteDBSingle_Set(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_WriteDBSingle_Get(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);

short _stdcall SPC_SetReadDB(short iBoardID,short iDBNr,short iOffset,short iAnzahl);
short _stdcall SPC_GetReadDB(short iBoardID,short *pValue);
short _stdcall SPC_SetWriteDB(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_GetWriteDB(short iBoardID);

short _stdcall SPC_ReadDX(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_WriteDX(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);

short _stdcall SPC_ReadWriteDB(short iBoardID,SPCREADWRITEDB stDB);
short _stdcall SPC_ReadWriteDB2(short iBoardID,SPCREADWRITEDB2 stDB);

short _stdcall SPC_ReadDXV2(short iBoardID,short iDBNr,short iOffset,short iAnzahl,short *pValue);

short _stdcall SPC_SetReadDX(short iBoardID,short iDBNr,short iOffset,short iAnzahl);
short _stdcall SPC_GetReadDX(short iBoardID,short *pValue);

short _stdcall SPC_GetDLLError();
void _stdcall SPC_ClearDLLError();
short _stdcall SPC_GetZyklusZeit(short iBoardID,short *iTime);

short _stdcall SPC_MemCs16ON(short iBoardID);
short _stdcall SPC_MemCs16OFF(short iBoardID);

short _stdcall SPC_GetSPSStatus(short iBoardID);

short _stdcall SPC_ReadSMerker(short iBoardID,short iOffset, short iAnzahl, unsigned char *pValue);
short _stdcall SPC_WriteSMerker(short iBoardID,short iOffset,short iAnzahl, unsigned char *pValue);

short _stdcall SPC_ReadMerkerS7(short iBoardID,short iOffset, short iAnzahl, unsigned char *pValue);
short _stdcall SPC_WriteMerkerS7(short iBoardID,short iOffset,short iAnzahl,char *pValue);
short _stdcall SPC_WriteMerkerWortS7(short iBoardID,short iOffset,short iAnzahl,short *pValue);
short _stdcall SPC_ReadMerkerWortS7(short iBoardID,short iOffset, short iAnzahl, short *pValue);

short _stdcall SPC_ReadPBAByteS7(short iBoardID,short Nr, unsigned char *Value);
short _stdcall SPC_ReadPBEByteS7(short iBoardID,short Nr, unsigned char *Value);

#ifdef __cplusplus
}
#endif
